Imports System.Collections
'UPDATE LOG
'==========
'****************************************************************************
'VER    DATE      CHANGE
'1.0    02/01/05  WORKSTATION APPLICATION CREATED
'****************************************************************************

Module DisplayLimits
    'Grid Size
    Public Const TileSize = 16
    Public Const Max_SymbolCode = 159
    Public Const Max_X = 80
    Public Const Max_Y = 64
    Public CurrentX As Integer = 0
    Public CurrentY As Integer = 0
    Public SymbolStore As Bitmap() = New Bitmap(Max_SymbolCode) {}

    Public Function CreateSymbolStore()
        Dim SymbolFile As Bitmap = Bitmap.FromFile("Symbols.png")
        Dim i As Integer
        For i = 0 To Max_SymbolCode
            SymbolStore(i) = SymbolFile.Clone(New Rectangle(i * TileSize, 0, TileSize, TileSize), Drawing.Imaging.PixelFormat.DontCare)
        Next i
        SymbolFile.Dispose()

    End Function

    Public Function MakePoint(ByVal x As Integer, ByVal y As Integer) As Point
        Dim p As Point
        p.X = x
        p.Y = y
        Return p
    End Function

End Module

' Panel Tile - One created for each tile of panel.
Public Class PanelTile
    Private SymbolCode As Integer = 156
    Private TileImage As Bitmap
    Private TileLocationRectangle As Rectangle = New Rectangle(0, 0, 16, 16)

    Public Sub New(ByVal Symbol As Integer, ByVal xLocation As Integer, ByVal yLocation As Integer)
        If xLocation >= 0 And xLocation <= Max_X And yLocation >= 0 And yLocation <= Max_Y Then
            TileLocationRectangle.X = xLocation * TileSize
            TileLocationRectangle.Y = yLocation * TileSize
        End If
        ChangeSymbol(Symbol)
    End Sub

    Public Function ChangeSymbol(ByVal Symbol As Integer) As Rectangle
        If Symbol >= 0 And Symbol <= Max_SymbolCode Then SymbolCode = Symbol
        TileImage = SymbolStore(SymbolCode).Clone
        Return TileLocationRectangle
    End Function

    Public Sub Draw(ByVal graphicsObect As Graphics)
        graphicsObect.DrawImage(TileImage, TileLocationRectangle)
    End Sub

    Public ReadOnly Property TileLocation() As Rectangle
        Get
            Return TileLocationRectangle
        End Get
    End Property

    Public ReadOnly Property Symbol() As Integer
        Get
            Return SymbolCode
        End Get
    End Property
End Class
