Imports System.Threading
Imports System.Net
Imports System.IO

Public Class ServerClass

    Public Listener As Sockets.TcpListener
    Private started As Boolean = False
    Private Lipthread As Threading.Thread
    Private NetPresent As Boolean = False
    Private LIP As String = "127.0.0.1"
    Private WithEvents Timer As New Timers.Timer(100)
    Public Function LocalIP() As String
        Return LIP
    End Function
    Public Function isRunning() As Boolean
        Return Me.started
    End Function
    Public Sub New(ByVal port As Integer)
        InitServer(port)
    End Sub
    Private Sub InitServer(ByVal Port As Integer)
        GetLocalIP()
        If Me.NetPresent Then
            Listener = New Sockets.TcpListener(IPAddress.Parse(LIP), Port)
        Else
            MessageBox.Show("Network Unavailable or blocked." & vbCrLf & "Ensure your Network is connected and Firewall set to enable MRCCC to communicate on Port " & Port & vbCr & vbCr & "MRCCC will try again once you acknowledge this box." & vbCrLf & "If Network remains unavailable, MultiUser will not be available - restart MRCCC to try again", mrcc)
            Listener = New Sockets.TcpListener(IPAddress.Parse(LIP), Port)
        End If
    End Sub
    Private Sub GetLocalIP()
        Lipthread = New Threading.Thread(AddressOf LocalIPThreadSub)
        Lipthread.Priority = Threading.ThreadPriority.Highest
        Lipthread.Start()
        System.Threading.Thread.CurrentThread.Sleep(1200)
        Lipthread.Abort()
    End Sub
    Public Sub StartServer()
        If Not started Then
            Listener.Start()
            Timer.Start()
            Timer.Enabled = True
            started = True
        End If
    End Sub
    Private Sub LocalIPThreadSub()
        Try
            Dim Dns As System.Net.Dns
            LIP = Dns.Resolve(System.Net.Dns.GetHostName).AddressList(0).ToString()
            NetPresent = True
        Catch ex As Exception

        End Try
    End Sub
    Private Sub AcceptClients(ByVal o As Object, ByVal e As System.Timers.ElapsedEventArgs) Handles Timer.Elapsed
        Try
            If Listener.Pending Then
                Timer.Enabled = False
                GUI.ClientConnections.Add("temp", New ClientConnection(Listener.AcceptSocket()))
                Dim Thread As New Threading.Thread(AddressOf CType(GUI.ClientConnections("temp"), ClientConnection).Run)
                Thread.Start()
                Timer.Enabled = True
            End If
        Catch
        End Try
    End Sub

    Public Sub StopServer()
        If started Then
            Timer.Enabled = False
            Timer.Stop()
            Listener.Stop()
            started = False
        End If
    End Sub

End Class

Public Class ClientConnection
    Public Event IncomingMessage(ByVal eventargs As InMessEvArgs)
    Private connection As Sockets.Socket
    Private serverIP As String
    Private socketstream As Sockets.NetworkStream
    Dim REP As System.Net.IPEndPoint = connection.RemoteEndPoint
    Dim ClientIP As String = REP.Address.ToString
    Dim theReply As String = ""

    Private writer As BinaryWriter
    Private reader As BinaryReader

    Sub New(ByVal socketValue As Sockets.Socket)
        connection = socketValue

        socketstream = New Sockets.NetworkStream(connection)
        writer = New BinaryWriter(socketstream)
        reader = New BinaryReader(socketstream)

        System.Threading.Thread.CurrentThread.Name = "Connection to " & ClientIP
    End Sub

    Public Sub Send(ByVal message As String)
        writer.Write(message)
    End Sub

    Public Sub Disconnect()
        Me.Disconnect()
    End Sub

    Public Sub Run()
        Try
            'Loop until connection terminated with Client
            Do
                theReply = reader.ReadString()
                Dim args As New InMessEvArgs(theReply, ClientIP)
                GUI.OnIncomingMessage(args)
            Loop While (theReply <> "*BYE*" AndAlso connection.Connected)

        Catch inputoutputexception As IOException
            If GUI.IPexistsAsUser(ClientIP) Then
                GUI.RemoveUser(GUI.GetUserIDbyIP(ClientIP))
            Else
                MessageBox.Show("Error with Connection to " & ClientIP & vbCr & vbCr & "Connection Closed", mrcc)
            End If
        Finally
            GUI.ClientConnections.Remove(ClientIP)
            writer.Close()
            reader.Close()
            socketstream.Close()
            connection.Close()
        End Try
    End Sub

    Public ReadOnly Property ClientsIP() As String
        Get
            If ClientIP <> "" Then
                Return ClientIP
            Else
                Return "0.0.0.0"
            End If
        End Get
    End Property

    

End Class